using DualScreenDemo;
using System;
using System.IO;
namespace DBObj
{
    public class SongData
    {
        public string Number { get; set; }
        public string Name { get; set; }
        public string Artist_A { get; set; }
        private string Artist_B { get; set; }
        public string FileName { get; set; }
        public string Artist_A_Simplified { get; set; }
        public string Artist_B_Simplified { get; set; }
        public string Name_Simplified { get; set; }
        public int HumanVoice { get; set; }
        public bool isPublicSong { get; set; }

        public PlayState state;

        /*
        public SongData(string songNumber, string category, string song, double plays, string artistA, string artistB, string artistACategory, string artistBCategory, DateTime addedTime, string songFilePathHost1, string songFilePathHost2, string phoneticNotation, string pinyinNotation, string artistAPhonetic, string artistBPhonetic, string artistASimplified, string artistBSimplified, string songSimplified, string songGenre, string artistAPinyin, string artistBPinyin, int humanVoice)
        {
            SongNumber = songNumber;
            // Category = category;
            Song = song;
            // Plays = plays;
            ArtistA = artistA;
            ArtistB = artistB;
            //ArtistACategory = artistACategory;
            //ArtistBCategory = artistBCategory;
            //AddedTime = addedTime;
            SongFilePathHost1 = songFilePathHost1; 
            SongFilePathHost2 = songFilePathHost2;
            //PhoneticNotation = phoneticNotation; 
            //PinyinNotation = pinyinNotation;
            //ArtistAPhonetic = artistAPhonetic;
            //ArtistBPhonetic = artistBPhonetic;
            ArtistASimplified = artistASimplified;
            ArtistBSimplified = artistBSimplified;
            SongSimplified = songSimplified;
            //SongGenre = songGenre;
            //ArtistAPinyin = artistAPinyin;
            //ArtistBPinyin = artistBPinyin;
            HumanVoice = humanVoice; 
        }
        
        */
        public SongData(string songNumber, string song, string filename, int humanVoice, bool isPublic)
        {
            Number = songNumber;
            Name = song;
            FileName = filename;
            HumanVoice = humanVoice;
            isPublicSong = isPublic;
        }
        public SongData(string songNumber, string song, string artistA, string artistB, string filename, string artistASimplified, string artistBSimplified, string songSimplified, int humanVoice)
        {
            Number = songNumber;
            Name = song;
            Artist_A = artistA;
            Artist_B = artistB;
            FileName = filename;
            Artist_A_Simplified = artistASimplified;
            Artist_B_Simplified = artistBSimplified;
            Name_Simplified = songSimplified;
            HumanVoice = humanVoice;
            isPublicSong = false;
        }
        public string getName(bool IsSimplified=false)
        {
            return IsSimplified ? Name_Simplified : Name;
        }
        public int getNameLength()
        {
            return Name.Length;
        }
        public string next_artist_text()
        {
            return !string.IsNullOrWhiteSpace(Artist_B)
                ? String.Format("下一首：{0}  {1} {2}", Artist_A, Artist_B, Name)
                : String.Format("下一首：{0}  {1}", Artist_A, Name);
        }
        public string artist_text()
        {
            return !string.IsNullOrWhiteSpace(Artist_B)
                    ? $"{Artist_A} - {Artist_B}"
                    : Artist_A;
        }
        public string name_text()
        {
            return !string.IsNullOrWhiteSpace(Artist_B)
                ? String.Format("{0} - {1} - {2}", Artist_A, Artist_B, Name)
                : String.Format("{0} - {1}", Artist_A, Name);
        }
        public string getArtist_A(bool IsSimplified)
        {
            return IsSimplified ? Artist_A_Simplified : Artist_A;
        }
        public string getArtist_B(bool IsSimplified)
        {
            return IsSimplified ? Artist_B_Simplified : Artist_B;
        }
        public string getFile()
        {
            return FindExistingPath(FileName);
        }
        private string FindExistingPath(string filename)
        {
            var servers = new[] { @"\\svr01\", @"\\svr02\", @"\\svr01\e", @"\\svr02\e" };
            foreach (var server in servers)
            {
                string fullPath = Path.Combine(server, filename);
                if (File.Exists(fullPath)) return fullPath;
            }
            return null; // 找不到就回原本的 filename，不加路徑
        }
        public void SetState(PlayState s) => state = s;

        public PlayState GetState()
        {
            return state;
        }

        
        public override string ToString()
        {

            return !string.IsNullOrWhiteSpace(Artist_B)
                ? String.Format("{0} - {1} - {2}", Artist_A, Artist_B, Name)
                : String.Format("{0} - {1}", Artist_A, Name);
        }
    }
}